local TracerName, TracerData = ...

--Informations locales
local MythicN = {
	[399] = "RLP", --
	[400] = "NO", --
	[401] = "AV", --
	[402] = "AA", --
	[165] = "SBG", --
	[200] = "HoV", --
	[210] = "CoS", --
	[2] = "TJS", --	
	};
TracerData.MythicNames = {
	--Dragonflight
	[399] = "", --"Bassins de l’Essence rubis"
	[400] = "", --"L’offensive nokhud"
	[401] = "", --"Caveau d’Azur"
	[402] = "", --"Académie d’Algeth’ar"
	
	--Shadowlands
	[375] = "", --"Brume de Tirna Scithe"
	[376] = "", --"Silliage nécrotique"
	[377] = "", --"L'Autre côté"
	[378] = "", --"Salles de l'Expiation"
	[379] = "", --"Malepeste"
	[380] = "", --"Profondeurs Sanguines"
	[381] = "", --"Flèches de l'Ascension"
	[382] = "", --"Théâtre de la Souffrance"
	[391] = "", --"Tazavesh : rue"	
	[392] = "", --"Tazavesh : Sol'leah"
	--Battle for Azeroth
	[369] = "", --"Opération Mécagone : casse"
	[370] = "", --"Opération Mécagone : atelier"
	--Legion
	[197] = "", --"L'oeil d'Azshara"
	[198] = "", --"Fourré Sombrecoeur"
	[199] = "", --"Bastion du Freux"
	[200] = "", --"Salles des Valeureux"
	[206] = "", --"Repaire de Neltharion"
	[207] = "", --"Caveau des Gardiennes"
	[210] = "", --"Cours des Etoiles"
	[234] = "", --"Retour à Karazhan : sommet"
	[227] = "", --"Retour à Karazhan : bas"	
	--Mist of Pandaria
	[2] = "", --Temple du serpent de Jade
	--WoD
	[165] = "", --"Terres sacrées d’Ombrelune"
	[369] = "", --"Opération Mécagone : casse"
	[370] = "", --"Opération Mécagone : atelier"	
	};
local order = {399, 400, 401, 402, 165, 200, 210, 2, 2358, 2381, 2379, 2354};

local MythicTazavesh = 0;
TracerData.verifmm = 0;
local MythicTazaveshEncountersId = {
	{2425, 2441, 2424, 2440},
	{2437, 2426, 2419, 2442},
};

function TracerData.Function:ButtonsIG()
	--Bouton Fermer
	TracerData.Buttons.CloseWindow = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.CloseWindow:SetPoint("BOTTOMRIGHT", TracerData.Headers[1], "TOPRIGHT", 0, 5);
	TracerData.Buttons.CloseWindow:SetSize(15, 15);
	TracerData.Buttons.CloseWindow:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\close_normal");	
	TracerData.Buttons.CloseWindow:SetScript("OnClick", function()
		TracerData.Function:CloseTracer();
		end);
	--Bouton Options
	TracerData.Buttons["Options"] = CreateFrame("Button", "ToggleOptions", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons["Options"]:SetPoint("BOTTOMRIGHT", TracerData.Headers[1], "TOPRIGHT", -20, 5);
	TracerData.Buttons["Options"]:SetSize(15, 15);
	TracerData.Buttons["Options"]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\option_normal");
	TracerData.Buttons["Options"]:SetScript("OnClick", function()
		TracerData.Function:OptionsTracer();
		end);
	-- Bouton Custom
	TracerData.Buttons.Custom = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.Custom:SetPoint("TOPRIGHT", TracerData.Headers[1], "TOPLEFT", -5, 0);
	TracerData.Buttons.Custom:SetSize(16, 16);
	TracerData.Buttons.Custom:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\custom_normal");
	TracerData.Buttons.Custom:SetScript("OnClick", function(self, button, down)
		TracerData.Function:DisplayCustom();
		end);
	-- Tooltip Bouton Custom
	TracerData.Buttons.Custom:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.Custom, "BOTTOMLEFT");		
		GameTooltip:AddLine(TracerData.L["Personnalisé"]);		
		GameTooltip:AddLine(TracerData.L["Afficher les informations relatives \nà votre sélection \npar le menu options"]);	
		GameTooltip:Show();			
	end);
	TracerData.Buttons.Custom:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);
	--Bouton DF
	TracerData.Buttons.DF = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.DF:SetPoint("TOPRIGHT", TracerData.Buttons.Custom, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.DF:SetSize(32, 16);
	TracerData.Buttons.DF:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\df_normal");
	TracerData.Buttons.DF:SetScript("OnClick", function(self, button, down)		
		TracerData.Function:DisplayDF();			
		end);
	--Tooltip Bouton DF
	TracerData.Buttons.DF:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.DF, "BOTTOMLEFT");		
		GameTooltip:AddLine("Dragonflight");		
		GameTooltip:AddLine(TracerData.L["Afficher les informations \nrelatives à DF uniquement"]);	
		GameTooltip:Show();			
	end);
	TracerData.Buttons.DF:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);			
	--Bouton SL
	TracerData.Buttons.SL = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.SL:SetPoint("TOPRIGHT", TracerData.Buttons.DF, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.SL:SetSize(32, 16);
	TracerData.Buttons.SL:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\sl_normal");
	TracerData.Buttons.SL:SetScript("OnClick", function(self, button, down)		
		TracerData.Function:DisplaySL();			
		end);
	--Tooltip Bouton SL
	TracerData.Buttons.SL:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.SL, "BOTTOMLEFT");		
		GameTooltip:AddLine("Shadowlands");		
		GameTooltip:AddLine(TracerData.L["Afficher les informations \nrelatives à SL uniquement"]);	
		GameTooltip:Show();			
	end);
	TracerData.Buttons.SL:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);	
	--Bouton BfA
	TracerData.Buttons.BfA = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.BfA:SetPoint("TOPRIGHT", TracerData.Buttons.SL, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.BfA:SetSize(32, 16);
	TracerData.Buttons.BfA:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\bfa_normal");
	TracerData.Buttons.BfA:SetScript("OnClick", function(self, button, down)		
		TracerData.Function:DisplayBfA();			
		end);
	--Tooltip Bouton BfA
	TracerData.Buttons.BfA:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.BfA, "BOTTOMLEFT");		
		GameTooltip:AddLine("Battle for Azeroth");		
		GameTooltip:AddLine(TracerData.L["Afficher les informations \nrelatives à BfA uniquement"]);	
		GameTooltip:Show();			
	end);
	TracerData.Buttons.BfA:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);
	--Bouton Legion
	TracerData.Buttons.Legion = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.Legion:SetPoint("TOPRIGHT", TracerData.Buttons.BfA, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.Legion:SetSize(32, 16);
	TracerData.Buttons.Legion:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\legion_normal");	
	TracerData.Buttons.Legion:SetScript("OnClick", function(self, button, down)				
		TracerData.Function:DisplayLegion();		
		end);
	--Tooltip Bouton Legion
	TracerData.Buttons.Legion:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.Legion, "BOTTOMLEFT");		
		GameTooltip:AddLine("Legion");		
		GameTooltip:AddLine(TracerData.L["Afficher les informations \nrelatives à Legion uniquement"]);	
		GameTooltip:Show();		
	end);
	TracerData.Buttons.Legion:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);
	--Bouton WoD
	TracerData.Buttons.WoD = CreateFrame("Button", "TracerCloseWindowButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.WoD:SetPoint("TOPRIGHT", TracerData.Buttons.Legion, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.WoD:SetSize(32, 16);
	TracerData.Buttons.WoD:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\wod_normal");	
	TracerData.Buttons.WoD:SetScript("OnClick", function(self, button, down)				
		TracerData.Function:DisplayWoD();	
		end);
	--Tooltip Bouton WoD
	TracerData.Buttons.WoD:SetScript("OnEnter", function()
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.WoD, "BOTTOMLEFT");		
		GameTooltip:AddLine("WoD");		
		GameTooltip:AddLine(TracerData.L["Afficher les informations \nrelatives à WoD uniquement"]);	
		GameTooltip:Show();		
	end);
	TracerData.Buttons.WoD:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);
	if (GetCurrentRegion() == 1) or (GetCurrentRegion() == 3) or (GetCurrentRegion() == 5) then
		-- Bouton Invasions
		TracerData.Buttons.Invasions = CreateFrame("Button", "TracerInvasionsButton", TracerData.Headers[1], "GameMenuButtonTemplate");
		TracerData.Buttons.Invasions:SetPoint("TOPRIGHT", TracerData.Buttons.WoD, "BOTTOMRIGHT", 0, -5);
		TracerData.Buttons.Invasions:SetSize(16, 16);
		TracerData.Buttons.Invasions:SetNormalTexture(132147);
		TracerData.Buttons.Invasions:SetScript("OnClick", function(self, button, down)
			
			end);
		-- Tooltip Bouton Invasions
		TracerData.Buttons.Invasions:SetScript("OnEnter", function()
			TracerData.Function:InvasionsTooltip();		
		end);
		TracerData.Buttons.Invasions:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);		
	end
	-- Bouton BattlePet
	TracerData.Buttons.BattlePet = CreateFrame("Button", "TracerBattlePetButton", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons.BattlePet:SetPoint("TOPRIGHT", TracerData.Buttons.Invasions, "BOTTOMRIGHT", 0, -5);
	TracerData.Buttons.BattlePet:SetSize(16, 16);
	TracerData.Buttons.BattlePet:SetNormalTexture(1719412);
	TracerData.Buttons.BattlePet:SetScript("OnClick", function(self, button, down)
		
		end);
	-- Tooltip Bouton BattlePet
	TracerData.Buttons.BattlePet:SetScript("OnEnter", function()
		TracerData.Function:BattlePetTooltip();		
	end);
	TracerData.Buttons.BattlePet:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);	
	--Déplacement de la fenêtre
	TracerData.Headers[1]:SetScript("OnMouseDown", function() 
		TracerData.Headers[1]:SetMovable(true); --Autorisation de déplacer la fenêtre
		TracerData.Headers[1]:StartMoving();
		end) --Autorisation
	TracerData.Headers[1]:SetScript("OnMouseUp", function() 
		TracerDB.Options.anchorleft = TracerData.Headers[1]:GetLeft();
		TracerDB.Options.anchortop = TracerData.Headers[1]:GetTop();
		TracerData.Headers[1]:StopMovingOrSizing();
		TracerData.Headers[1]:ClearAllPoints();
		TracerData.Headers[1]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TracerDB.Options.anchorleft, TracerDB.Options.anchortop);
		end) --Blocage
	--Cacher avec la touche 'Esc'
	TracerData.Headers[1]:EnableKeyboard(true);	--Autorise l'interraction avec le clavier
	TracerData.Headers[1]:SetPropagateKeyboardInput(true);	--Pour ne pas consumer le 'ESC'
	TracerData.Headers[1]:SetScript("OnKeyDown", function(self, key)
		if key == "ESCAPE" then 
			TracerData.Function:CloseTracer();
		end
		end)	
	--Bouton pour défiler les Toons
	TracerData.Buttons["toonminus"] = CreateFrame("Button", "Button_ToonMinus", TracerData.Headers[1]);
	TracerData.Buttons["toonminus"]:SetSize(20, 20);
	TracerData.Buttons["toonminus"]:SetPoint("BOTTOMLEFT", TracerData.Headers[1], "TOPLEFT", 5, 5);
	TracerData.Buttons["toonminus"]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-MinusButton-Up");
	TracerData.Buttons["toonminus"]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-MinusButton-Down");		
	TracerData.Buttons["toonminus"]:SetScript("OnClick", function()	
		TracerDB.Options.Page = TracerDB.Options.Page - 1;
		if TracerDB.Options.Page == 0 then
			TracerDB.Options.Page = 1;
		end
		TracerData.Function:UpdateAnchors()
		end)	
	TracerData.Buttons["toonplus"] = CreateFrame("Button", "Button_ToonMinus", TracerData.Headers[1]);
	TracerData.Buttons["toonplus"]:SetSize(20, 20);
	TracerData.Buttons["toonplus"]:SetPoint("LEFT", TracerData.Buttons["toonminus"], "RIGHT", 5, 0);
	TracerData.Buttons["toonplus"]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-PlusButton-Up");
	TracerData.Buttons["toonplus"]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-PlusButton-Down");		
	TracerData.Buttons["toonplus"]:SetScript("OnClick", function()	
		if #TracerData.ListToons > TracerDB.Options.Page*10 then
			TracerDB.Options.Page = TracerDB.Options.Page + 1;
		end
		TracerData.Function:UpdateAnchors()
		end)
	if #TracerData.ListToons <= 10 then
	TracerData.Buttons["toonminus"]:Hide();
	TracerData.Buttons["toonplus"]:Hide();
	end
	--Bouton pour afficher la Chambre Forte
	TracerData.Buttons["greatvault"] = CreateFrame("Button", "Button_GreatVault", TracerData.Headers[1], "GameMenuButtonTemplate");
	TracerData.Buttons["greatvault"]:SetSize(100, 20);
	TracerData.Buttons["greatvault"]:SetPoint("BOTTOMLEFT", TracerData.Headers[1], "TOPLEFT", 70, 5);
	TracerData.Buttons["greatvault"]:SetText(TracerData.L["CF"]);	
	TracerData.Buttons["greatvault"]:SetScript("OnClick", function()	
		LoadAddOn("Blizzard_WeeklyRewards");
		WeeklyRewardsFrame:Show();
		TracerData.Function:CloseTracer();
		end)
end

function TracerData.Function:WindowCreateGeneralInfos()
	--DB pour l'affichage
	--Donjons Mythiques (extension en cours)
	local t = C_ChallengeMode.GetMapTable();

	for index, value in pairs(t) do
		local name, id, timeLimit, texture, backgroundTexture = C_ChallengeMode.GetMapUIInfo(value)
		if name then
			TracerDB.MythicInfo[value] = name;
		end
	end
	local name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _  = GetLFGDungeonInfo(2358);	--Neltharus
	TracerData.MythicNames[2358] = name2;
	TracerDB.MythicInfo[2358] = name2;
	name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _  = GetLFGDungeonInfo(2381);			--Salles de l'imprégnation
	TracerData.MythicNames[2381] = name2;
	TracerDB.MythicInfo[2381] = name2;
	name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _  = GetLFGDungeonInfo(2379);			--Creux des Fougerobes
	TracerData.MythicNames[2379] = name2;
	TracerDB.MythicInfo[2379] = name2;
	name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _  = GetLFGDungeonInfo(2354);			--Uldaman : Héritage de Tyr
	TracerData.MythicNames[2354] = name2;
	TracerDB.MythicInfo[2354] = name2;
	
	for key, value in pairs(TracerData.MythicNames) do
		local name, id, timeLimit, texture, backgroundTexture = C_ChallengeMode.GetMapUIInfo(key);
		if name then
			TracerData.MythicNames[key] = name;
		end
	end
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[1];
	TracerDB.ListLine[1] = {
		TracerData.L["Pseudo"],
		TracerData.L["Ilvl"],
		TracerData.L["Donjon héro du jour"],
		TracerData.L["Donjon Mythique"],
		TracerData.L["La chambre-forte"],
		TracerData.L["Clé disponible"],	
		};	
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(1, headername);	
	TracerData.Headers[1]:Hide();
	--Changement de police pour les clés
	for i=1, #TracerData.ListToons do
		TracerData.Lines[1]["Toon"..i][6]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", 10);
	end
	--Création des boutons (options/fermer/selection/page + déplacement de la fenêtre)
	TracerData.Function:ButtonsIG()

	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
	
	--Désactivation des boutons pour afficher le ToonPanel
	local totalframe = 1;
	if #TracerData.ListToons <= 10 then
		totalframe = #TracerData.ListToons
	elseif #TracerData.ListToons <= 20 then
		totalframe = 20;
	elseif #TracerData.ListToons <= 30 then
		totalframe = 30;		
	elseif #TracerData.ListToons <= 40 then
		totalframe = 40;		
	else
		totalframe = 50;		
	end
	local start = 11;
	for i=1, totalframe, 1 do	
		if not TracerData.Lines[1]["Toon"..i][1]["Title"]:GetText() then
			TracerData.Lines[1]["Toon"..i][1]:Disable();
		end
	end
	
	--Création de la fenêtre d'affichage des ilvl des loots en mm+
	TracerData.Function:MythicPlusIlvlLootFrameCreate();
	--Création de la fenêtre d'affichage des clés mm+
	TracerData.Function:MythicPlusKeyFrameCreate();
	--Création de la fenêtre d'affichage du résumé mm+
	TracerData.Function:MythicPlusResumeCreate();
		
	--Tooltip pour les PO
	TracerData.Lines[1][1]:RegisterEvent("PLAYER_MONEY");	
	TracerData.Lines[1][1]:SetScript("OnEvent", function()
		TracerDB["Toons"][TracerData.thisToon]["PO"] = GetMoney() / 10000 - GetMoney() % 10000 / 10000 ;
	end);	
	TracerData.Lines[1][1]:SetScript("OnEnter", function()
		TracerData.Function:GoldTooltip();
	end);	
	TracerData.Lines[1][1]:SetScript("OnLeave", function()
		GameTooltip:Hide();
	end);	
	
	--Tooltip pour les TracerDB.MythicInfo+
	TracerData.Lines[1][4]:SetScript("OnEnter", function()
		TracerData["MythicIlvlLootFrame"]:Show();
	end);
	TracerData.Lines[1][4]:SetScript("OnLeave", function()
		TracerData["MythicIlvlLootFrame"]:Hide();
	end);	
	
	--Tooltip pour les vérouillage de Mythic+
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[1]["Toon"..index][4]:SetScript("OnEnter", function()
			TracerData.Function:MythicPlusResumeUpdate(value);
		end);
		TracerData.Lines[1]["Toon"..index][4]:SetScript("OnLeave", function()
			TracerData["MythicResumeFrame"]:Hide();
		end);	
	end	
	
	--Tooltip pour les clé Mythic+ dispo
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[1]["Toon"..index][6]:SetScript("OnEnter", function()
			TracerData.Function:MythicPlusKeyTooltip(value);
		end);
		TracerData.Lines[1]["Toon"..index][6]:SetScript("OnLeave", function()
			TracerData["MythicKeyFrame"]:Hide();
		end);	
	end		
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Actualitsation "Ilvl"
	TracerData.Lines[1][2]:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE");
	TracerData.Lines[1][2]:SetScript("OnEvent", function(_, event)
		TracerData.Function:IlvlChecking();
	end)

	--Actualisation "Donjon héros du jour"
	TracerData.Lines[1][3]:RegisterEvent("LFG_COMPLETION_REWARD");
	TracerData.Lines[1][3]:RegisterEvent("LFG_LOCK_INFO_RECEIVED");	
	TracerData.Lines[1][3]:SetScript("OnEvent", function(_, event) 
		if event == "LFG_COMPLETION_REWARD" then
			RequestLFDPlayerLockInfo();
		else
			TracerData.Function:HerodayChecking();
		end
	end)
	
	--Gestion du Mythique de la semaine
	TracerData.Lines[1][4]:RegisterEvent("CHALLENGE_MODE_START");		
	TracerData.Lines[1][4]:RegisterEvent("CHALLENGE_MODE_COMPLETED");	
	TracerData.Lines[1][4]:RegisterEvent("BOSS_KILL");	--Pour les mm0
	TracerData.Lines[1][4]:RegisterEvent("CHALLENGE_MODE_MAPS_UPDATE");
	TracerData.Lines[1][4]:RegisterEvent("CHALLENGE_MODE_LEADERS_UPDATE");	
	TracerData.Lines[1][4]:RegisterEvent("WEEKLY_REWARDS_UPDATE");	
	TracerData.Lines[1][4]:RegisterEvent("PLAYER_ENTERING_WORLD");	
	TracerData.Lines[1][4]:SetScript("OnEvent", function(_, event, arg1, arg2)													
		TracerData.verifmm = 10;
		if event == "CHALLENGE_MODE_START" then
			if arg1 == 2225 then
				TracerData.Lines[1][4]:RegisterEvent("BOSS_KILL");
				MythicTazavesh = 2225;
			else		
				MythicTazavesh = 0;
			end
		elseif event == "BOSS_KILL" then
			TracerData.Lines[1][4]:UnregisterEvent("BOSS_KILL");
			for index, value in ipairs(MythicTazaveshEncountersId[1]) do
				if arg1 == value then
					MythicTazavesh = 22251;
				end
			end
			for index, value in ipairs(MythicTazaveshEncountersId[2]) do
				if arg1 == value then
					MythicTazavesh = 22252;
				end
			end		
		else
			TracerDB.Toons[TracerData.thisToon]["MythicReward"] = C_WeeklyRewards.GetActivities(1);
			TracerData.Function:MythicPlusBestWeeklyChecking();				
		end		
	end)
	
	--Gestion du Coffre Mythique+ à récupérer
	TracerData.Lines[1][5]:RegisterEvent("BAG_UPDATE");	
	TracerData.Lines[1][5]:SetScript("OnEvent", function(_, event)
		C_MythicPlus.RequestRewards();
		C_Timer.After(5, function() TracerData.Function:MythicPlusChest() end);
	end)

	--Gestion du scan de la clé m+ dans le sac
	TracerData.Lines[1][6]:RegisterEvent("BAG_UPDATE");
	TracerData.Lines[1][6]:RegisterEvent("UNIT_INVENTORY_CHANGED");
	TracerData.Lines[1][6]:RegisterEvent("CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN");
	TracerData.Lines[1][6]:SetScript("OnEvent", function(_, event)
		TracerData.Function:MythicPlusKey();
	end)
end

function TracerData.Function:WindowUpdateGeneralInfos()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[1] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon
				if value == key1 then
					TracerData.Lines[1]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Pseudo"
					if i == 1 then
						TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(value1.Name);		
					end	
					--"Ilvl"
					if i == 2 then
						TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(value1.Ilvl);
					end		
					--"Donjon héro du jour"
					if i == 3 then
						if value1["Quests"]["HD"] == 0 then
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);						
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["HD"] == 1 then
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);						
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText("NA");
						end								
					end	
					--"Donjon mythique"
					if i == 4 then
						if value1["Quests"]["MD"] == -2 then
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText("NA");
						elseif value1["Quests"]["MD"] == -1 then
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);							
						else
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["MD"]);
						end							
					end	
					--"Coffre Mythique"
					if i == 5 then
						if value1["Quests"]["MC"] == -1 then						
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText("NA");						
						elseif value1["Quests"]["MC"] == 1 then
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);							
						else
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);						
						end
					end					
					--"Clé Disponible"
					if i == 6 then
						if value1.Level == 70 then
							if value1["Quests"]["MK"][2] == -1 then		
								TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText("NA");
							elseif value1["Quests"]["MK"][2] == 0 then
								TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
								TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(nil);
							else
								TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText(MythicN[value1["Quests"]["MK"][1]].." "..value1["Quests"]["MK"][2]);
							end
						else
							TracerData.Lines[1]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[1]["Toon"..index][i]["Title"]:SetText("NA");						
						end
					end											
				end
			end
		end
	end
end

--Frame pour scanner les MM+ fait
TracerData.ONUPDATE_INTERVAL2 = 10	-- The minimum number of seconds between each update
TracerData.TimeSinceLastUpdate2 = 0	-- The number of seconds since the last update
--Mise en route du scanner dans le core

--Fonctions pour les invasions
--/run print(time{year=2020, month=3, day=29, hour=14})
local invIndex = {
	["BfA"] = {
		title = "BfA : Faction Assaults",
		maps = {862, 863, 864, 896, 942, 895},
		rotation = {4, 1, 6, 2, 5, 3},
		duration = 25200,
		interval = 68400,
		-- Drustvar Beginning
		baseTime = {
			US = 1548032400, -- 01/20/2019 17:00 UTC-8
			EU = 1548000000, -- 01/20/2019 16:00 UTC+0
			CN = 1546743600, -- 01/06/2019 11:00 UTC+8
			},
		};
	["Legion"] = {
		title = "Legion : Invasions",
		maps = {630, 641, 650, 634},
		rotation = {4, 3, 2, 1, 4, 2, 3, 1, 2, 4, 1, 3},
		duration = 21600,
		interval = 66600,
		-- Stormheim Beginning then Highmountain
		baseTime = {
			US = 1547614800, -- 01/15/2019 21:00 UTC-8
			EU = 1547586000, -- 01/15/2019 21:00 UTC+0
			CN = 1546844400, -- 01/07/2019 15:00 UTC+8
			},
		},
	};
	
function TracerData.Function:GetCurrentInvasion(index)
    local inv = invIndex[index];
    local currentTime = time();
    local baseTime = inv.baseTime[TracerData.region];
    local duration = inv.duration;
    local interval = inv.interval;
    local elapsed = mod(currentTime - baseTime, interval);
    if elapsed < duration then
        local count = #inv.rotation
        local round = mod(floor((currentTime - baseTime) / interval) + 1, count)
		if round == 0 then round = count end		
		local namezone = C_Map.GetMapInfo(inv.maps[inv.rotation[round]]).name; 
		if index == "Legion" then
			namezone = " ";
		end
        return duration - elapsed, namezone
    end
end

function TracerData.Function:GetFutureInvasion(index)
	local tbl = {};
    local inv = invIndex[index];
    local currentTime = time();
    local baseTime = inv.baseTime[TracerData.region];
    local interval = inv.interval;
    local count = #inv.rotation;
    local elapsed = mod(currentTime - baseTime, interval);
    local nextTime = interval - elapsed + currentTime;
    local round = mod(floor((nextTime - baseTime) / interval) + 1, count);
	local namezone = " ";
    for i = 1, 2 do
		if round == 0 then round = count end
		if index == "Legion" then
			namezone = " ";
		else		
			namezone = C_Map.GetMapInfo(inv.maps[inv.rotation[round]]).name; 
		end
        table.insert(tbl, {nextTime, namezone})
        nextTime = nextTime + interval
        round = mod(round + 1, count)
    end
    return tbl
end

--Fonction pour les tooltips des mm+
function TracerData.Function:MythicPlusKeyFrameCreate()
	TracerData["MythicKeyFrame"] = TracerData.Function:CreateFrameOne("MythicKeyFrame", TracerData.Lines[1][6], TracerData.Lines[1][6], 300, 84, "TOP", "TOP", 0, 0, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, "");
	TracerData["MythicKeyFrame"]:SetFrameStrata("DIALOG"); --Couche sur laquelle la frame est placée
	--Nom de la clé
	TracerData["MythicKeyFrame"]["Title"]:SetPoint("LEFT", TracerData["MythicKeyFrame"], "TOPLEFT", 5, -10);
	TracerData["MythicKeyFrame"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police + 2);
	TracerData["MythicKeyFrame"]["Title"]:SetTextColor(TracerData.TextColor[1][1], TracerData.TextColor[1][2], TracerData.TextColor[1][3], TracerData.TextColor[1][4]);		
	TracerData["MythicKeyFrame"]["Title"]:SetText("Nom de la clé");		
	--Niveau de la clé
	TracerData["MythicKeyFrame"]["TitleKeyLevel"] = TracerData["MythicKeyFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police + 2);
	TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetTextColor(TracerData.TextColor[2][1], TracerData.TextColor[2][2], TracerData.TextColor[2][3], TracerData.TextColor[2][4]);		
	TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetPoint("RIGHT", TracerData["MythicKeyFrame"], "TOPRIGHT", -5, -10);
	TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetText("Lvl");
	--Affix 1
	local yOffset = -26;
	for i = 1, 4, 1 do
		TracerData["MythicKeyFrame"]["Affix"..i] = TracerData["MythicKeyFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicKeyFrame"]["Affix"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
		TracerData["MythicKeyFrame"]["Affix"..i]:SetTextColor(0, 1, 0, 1);		
		TracerData["MythicKeyFrame"]["Affix"..i]:SetPoint("LEFT", TracerData["MythicKeyFrame"], "TOPLEFT", 5, yOffset);
		TracerData["MythicKeyFrame"]["Affix"..i]:SetText("Affix "..i);
		yOffset = yOffset - 16;
	end	
	TracerData["MythicKeyFrame"]:Hide();
end

function TracerData.Function:MythicPlusIlvlLootFrameCreate()
	TracerData["MythicIlvlLootFrame"] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrame", TracerData.Lines[1][4], TracerData.Lines[1][4], 150, 340, "TOPRIGHT", "TOPLEFT", 0, 0, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, "");
	TracerData["MythicIlvlLootFrame"]["Title1"] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle1", TracerData["MythicIlvlLootFrame"], TracerData["MythicIlvlLootFrame"], 40, 10, "TOPLEFT", "TOPLEFT", 5, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, TracerData.L["Clé"]);
	TracerData["MythicIlvlLootFrame"]["Title2"] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle2", TracerData["MythicIlvlLootFrame"], TracerData["MythicIlvlLootFrame"], 40, 10, "TOP", "TOP", 0, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, "Loot");
	TracerData["MythicIlvlLootFrame"]["Title3"] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle3", TracerData["MythicIlvlLootFrame"], TracerData["MythicIlvlLootFrame"], 40, 10, "TOPRIGHT", "TOPRIGHT", -5, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, TracerData.L["Coffre"]);
	
	--Niveau de clé
	local j=0;
	local k=1;
	local ParentFrame = TracerData["MythicIlvlLootFrame"]["Title1"];
	for i=1, 21, 1 do
		TracerData["MythicIlvlLootFrame"]["Title1"][j] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle1"..j, TracerData["MythicIlvlLootFrame"], ParentFrame, 40, 10, "TOP", "BOTTOM", 0, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, "+"..j);
		if k==1 then
			TracerData["MythicIlvlLootFrame"]["Title1"][j]["Title"]:SetTextColor(1, 0.6, 0.2, 1);
			k=2;
		else
			TracerData["MythicIlvlLootFrame"]["Title1"][j]["Title"]:SetTextColor(1, 1, 1, 1);
			k=1;
		end		
		ParentFrame = TracerData["MythicIlvlLootFrame"]["Title1"][j];
		j=j+1;
	end
	--Loot
	local list = {
		"372",
		"372",
		"376",
		"376",
		"379",
		"379",
		"382",
		"385",
		"385",
		"389",
		"392",
		"392",
		"392",
		"392",
		"395",
		"398",
		"398",
		"402",
		"402",
		"405",
		"405",
		};
	k=1;
	j=0;
	ParentFrame = TracerData["MythicIlvlLootFrame"]["Title2"];
	for i=1, 21, 1 do
		TracerData["MythicIlvlLootFrame"]["Title2"][j] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle1"..j, TracerData["MythicIlvlLootFrame"], ParentFrame, 40, 10, "TOP", "BOTTOM", 0, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, list[i]);
		if k==1 then
			TracerData["MythicIlvlLootFrame"]["Title2"][j]["Title"]:SetTextColor(1, 0.6, 0.2, 1);
			k=2;
		else
			TracerData["MythicIlvlLootFrame"]["Title2"][j]["Title"]:SetTextColor(1, 1, 1, 1);
			k=1;
		end
		ParentFrame = TracerData["MythicIlvlLootFrame"]["Title2"][j];
		j=j+1;
	end	
	--Coffre
	list = {
		"--",
		"--",
		"382",
		"385",
		"385",
		"389",
		"389",
		"392",
		"395",
		"395",
		"398",
		"402",
		"405",
		"408",
		"408",
		"411",
		"415",
		"415",
		"418",
		"418",
		"421",
		};
	k=1
	j=0;
	ParentFrame = TracerData["MythicIlvlLootFrame"]["Title3"];	
	for i=1, 21, 1 do
		TracerData["MythicIlvlLootFrame"]["Title3"][j] = TracerData.Function:CreateFrameOne("MythicIlvlLootFrameTitle1"..j, TracerData["MythicIlvlLootFrame"], ParentFrame, 40, 10, "TOP", "BOTTOM", 0, -5, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, list[i]);
		if k==1 then
			TracerData["MythicIlvlLootFrame"]["Title3"][j]["Title"]:SetTextColor(1, 0.6, 0.2, 1);
			k=2;
		else
			TracerData["MythicIlvlLootFrame"]["Title3"][j]["Title"]:SetTextColor(1, 1, 1, 1);
			k=1;
		end
		ParentFrame = TracerData["MythicIlvlLootFrame"]["Title3"][j];		
		j=j+1;	
	end	
	
	TracerData["MythicIlvlLootFrame"]:Hide();
end

function TracerData.Function:MythicPlusKeyTooltip(toon)
	if (TracerDB.Toons[toon]["Quests"]["MK"][1] ~= 0) and (TracerDB.Toons[toon]["Level"] >=70) then	
		TracerData["MythicKeyFrame"]["Title"]:SetText(TracerDB.MythicInfo[TracerDB.Toons[toon]["Quests"]["MK"][1]]);
		TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetText(TracerDB.Toons[toon]["Quests"]["MK"][2]);
		local height = 20;
		for i=1, 4, 1 do	
			if TracerDB.Toons[toon]["Quests"]["MK"][i+2] ~= 0 then
				local nameaffix, _, _ = C_ChallengeMode.GetAffixInfo(TracerDB.Toons[toon]["Quests"]["MK"][i+2]);
				TracerData["MythicKeyFrame"]["Affix"..i]:SetText(nameaffix);
				height = height + 16;
				TracerData["MythicKeyFrame"]:SetHeight(height);	
			else
				TracerData["MythicKeyFrame"]["Affix"..i]:SetText(nil);
			end
		end	
		TracerData["MythicKeyFrame"]["Title"]:GetWidth()
		TracerData["MythicKeyFrame"]:SetWidth(TracerData["MythicKeyFrame"]["Title"]:GetWidth()+50);
		TracerData["MythicKeyFrame"]:ClearAllPoints();
		TracerData["MythicKeyFrame"]:SetPoint("BOTTOM", TracerData.Lines[1]["Toon"..TracerDB.Toons[toon]["Order"]][6], "TOP");
		TracerData["MythicKeyFrame"]:Show();
	end
end

function TracerData.Function:MythicPlusResumeCreate()
	local yOffset = -42;
	local maxlengthdungeonname = 0;
	TracerData["MythicResumeFrame"] = TracerData.Function:CreateFrameOne("MythicResumeFrame", TracerData.Lines[1][4], TracerData.Lines[1][4], 50, 480, "TOP", "TOP", 0, 0, 0, 0, 0, 1, "CENTER", "CENTER", 0, 0, "");
	TracerData["MythicResumeFrame"]:SetFrameStrata("DIALOG"); --Couche sur laquelle la frame est placée
	
	--Nom du joueur
	TracerData["MythicResumeFrame"]["Title"]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, -10);
	TracerData["MythicResumeFrame"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police + 2);		
	TracerData["MythicResumeFrame"]["Title"]:SetText("Name");		
	--Côte mm+
	TracerData["MythicResumeFrame"]["Score"] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicResumeFrame"]["Score"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police + 2);		
	TracerData["MythicResumeFrame"]["Score"]:SetPoint("RIGHT", TracerData["MythicResumeFrame"], "TOPRIGHT", -5, -10);
	TracerData["MythicResumeFrame"]["Score"]:SetText("Score");	
	--Nom des donjons
	for index, value in ipairs(order) do
		TracerData["MythicKeyFrame"][value] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicKeyFrame"][value]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
		TracerData["MythicKeyFrame"][value]:SetTextColor(1, 0, 0, 1);		
		TracerData["MythicKeyFrame"][value]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, yOffset);
		TracerData["MythicKeyFrame"][value]:SetText(TracerDB.MythicInfo[value]);
		yOffset = yOffset - 16;
		if TracerData["MythicKeyFrame"][value]:GetStringWidth() > maxlengthdungeonname then
			maxlengthdungeonname = TracerData["MythicKeyFrame"][value]:GetStringWidth()
		end
	end	

	yOffset = yOffset - 16;
	--Titre 2
	TracerData["MythicResumeFrame"]["Title2"] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicResumeFrame"]["Title2"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);	
	TracerData["MythicResumeFrame"]["Title2"]:SetTextColor(TracerData.TextColor[2][1], TracerData.TextColor[2][2], TracerData.TextColor[2][3], TracerData.TextColor[2][4]);		
	TracerData["MythicResumeFrame"]["Title2"]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, yOffset);
	TracerData["MythicResumeFrame"]["Title2"]:SetText(TracerData.L["Liste des mm+ fait cette semaine"].." (100)");
	yOffset = yOffset - 16;	
	--8 donjons de la semaine
	for i=1, 8, 1 do
		TracerData["MythicResumeFrame"]["MythicWeekName"..i] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["MythicWeekName"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["MythicWeekName"..i]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, yOffset);
		TracerData["MythicResumeFrame"]["MythicWeekName"..i]:SetText("MythicWeekName"..i);
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..i] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..i]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30, yOffset);
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..i]:SetText("+2");		
		yOffset = yOffset - 16;
	end	
	yOffset = yOffset - 16;		
	--Titre
	TracerData["MythicResumeFrame"]["Title3"] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicResumeFrame"]["Title3"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData["MythicResumeFrame"]["Title3"]:SetTextColor(TracerData.TextColor[2][1], TracerData.TextColor[2][2], TracerData.TextColor[2][3], TracerData.TextColor[2][4]);		
	TracerData["MythicResumeFrame"]["Title3"]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, yOffset);
	TracerData["MythicResumeFrame"]["Title3"]:SetText(TracerData.L["Ilvl des récompenses du coffre"]);
	yOffset = yOffset - 16;		
	--Ilvl des 3 coffres
	for i=1, 3, 1 do
		TracerData["MythicResumeFrame"]["Chest"..i] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["Chest"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["Chest"..i]:SetPoint("LEFT", TracerData["MythicResumeFrame"], "TOPLEFT", 5, yOffset);
		TracerData["MythicResumeFrame"]["Chest"..i]:SetText(TracerData.L["Coffre"].." "..i);
		TracerData["MythicResumeFrame"]["ChestLevel"..i] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["ChestLevel"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["ChestLevel"..i]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30, yOffset);
		TracerData["MythicResumeFrame"]["ChestLevel"..i]:SetText("100");		
		yOffset = yOffset - 16;
	end
	--Meilleur mm+ de la semaine
	yOffset = -42
	for index, value in ipairs(order) do
		TracerData["MythicResumeFrame"]["BW"..value] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["BW"..value]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["BW"..value]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30, yOffset);
		TracerData["MythicResumeFrame"]["BW"..value]:SetText("+20");
		yOffset = yOffset - 16;
	end	
	--Meilleur mm+ fortifié de la saison
	yOffset = -42
	for index, value in ipairs(order) do
		TracerData["MythicResumeFrame"]["BSF"..value] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["BSF"..value]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["BSF"..value]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30 + 40, yOffset);
		TracerData["MythicResumeFrame"]["BSF"..value]:SetText("+10");
		yOffset = yOffset - 16;
	end
	--Meilleur mm+ tyrannique de la saison
	yOffset = -42
	for index, value in ipairs(order) do
		TracerData["MythicResumeFrame"]["BST"..value] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["BST"..value]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["BST"..value]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30 + 40 + 30, yOffset);
		TracerData["MythicResumeFrame"]["BST"..value]:SetText("+10");
		yOffset = yOffset - 16;
	end
	--Score
	yOffset = -42
	for index, value in ipairs(order) do
		TracerData["MythicResumeFrame"]["Score"..value] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
		TracerData["MythicResumeFrame"]["Score"..value]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
		TracerData["MythicResumeFrame"]["Score"..value]:SetPoint("CENTER", TracerData["MythicResumeFrame"], "TOPLEFT", maxlengthdungeonname + 30 + 40 + 30 + 40, yOffset);
		TracerData["MythicResumeFrame"]["Score"..value]:SetText(value);
		yOffset = yOffset - 16;
	end
	--Type de donjon
	TracerData["MythicResumeFrame"]["DonjonF"] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicResumeFrame"]["DonjonF"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
	TracerData["MythicResumeFrame"]["DonjonF"]:SetPoint("CENTER", TracerData["MythicResumeFrame"]["BSF"..order[1]], "CENTER", 0, 16);
	TracerData["MythicResumeFrame"]["DonjonF"]:SetText("F");	
	TracerData["MythicResumeFrame"]["DonjonT"] = TracerData["MythicResumeFrame"]:CreateFontString(nil, "OVERLAY");
	TracerData["MythicResumeFrame"]["DonjonT"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);		
	TracerData["MythicResumeFrame"]["DonjonT"]:SetPoint("CENTER", TracerData["MythicResumeFrame"]["BST"..order[1]], "CENTER", 0, 16);
	TracerData["MythicResumeFrame"]["DonjonT"]:SetText("T");
		
	TracerData["MythicResumeFrame"]:SetWidth(maxlengthdungeonname + 160);
	TracerData["MythicResumeFrame"]:SetPoint("TOPLEFT", TracerData.Headers[1], "TOPRIGHT", 0, 0)
	TracerData["MythicResumeFrame"]:Hide();
end

function TracerData.Function:MythicPlusResumeUpdate(toon)
	if TracerDB.Toons[toon]["Level"] < 70 then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	local color = TracerDB.Toons[toon]["MythicScoreColor"];

	-- MythicResume[key] = {false, -1, -1, -1, -1, -1, -1, 0, 0, 0};	--MM0 (1), best timée weekly (2), best non timée weekly (3), 
																		--best season fortif (4) , timed or not (5)
																		--best season tyra (6), timed or not (7)
																		--score total (8), score fortified (9), score tyra (10)
																		
	--Nom
	TracerData["MythicResumeFrame"]["Title"]:SetText(TracerDB.Toons[toon]["Name"]);
	TracerData["MythicResumeFrame"]["Title"]:SetTextColor(r, g, b, 1);
	--Score
	TracerData["MythicResumeFrame"]["Score"]:SetText(TracerDB.Toons[toon]["MythicScore"]);
	TracerData["MythicResumeFrame"]["Score"]:SetTextColor(color.r, color.g, color.b, 1);	
	for index, value in pairs(order) do
		--Mythique 0 fait
		if TracerDB.Toons[toon]["Mythic"][value][1] then
			TracerData["MythicKeyFrame"][value]:SetTextColor(0, 1, 0, 1);
		else
			TracerData["MythicKeyFrame"][value]:SetTextColor(1, 0, 0, 1);		
		end
		
		--Meilleur mm+ de la semaine
		if TracerDB.Toons[toon]["Mythic"][value][2] ~= -1 then
			TracerData["MythicResumeFrame"]["BW"..value]:SetText(TracerDB.Toons[toon]["Mythic"][value][2]);
		else
			TracerData["MythicResumeFrame"]["BW"..value]:SetText("--");	
		end
		--Meilleur fortifié de la saison
		if TracerDB.Toons[toon]["Mythic"][value][4] ~= -1 then
			TracerData["MythicResumeFrame"]["BSF"..value]:SetText(TracerDB.Toons[toon]["Mythic"][value][4]);
			if not TracerDB.Toons[toon]["Mythic"][value][5] then
				TracerData["MythicResumeFrame"]["BSF"..value]:SetTextColor(0, 1, 0, 1);
			else
				TracerData["MythicResumeFrame"]["BSF"..value]:SetTextColor(1, 0, 0, 1);
			end
		else
			TracerData["MythicResumeFrame"]["BSF"..value]:SetText("--");
			TracerData["MythicResumeFrame"]["BSF"..value]:SetTextColor(1, 1, 1, 1);
		end
		--Meilleur tyrannique de la saison
		if TracerDB.Toons[toon]["Mythic"][value][6] ~= -1 then
			TracerData["MythicResumeFrame"]["BST"..value]:SetText(TracerDB.Toons[toon]["Mythic"][value][6]);
			if not TracerDB.Toons[toon]["Mythic"][value][7] then
				TracerData["MythicResumeFrame"]["BST"..value]:SetTextColor(0, 1, 0, 1);
			else
				TracerData["MythicResumeFrame"]["BST"..value]:SetTextColor(1, 0, 0, 1);
			end
		else
			TracerData["MythicResumeFrame"]["BST"..value]:SetText("--");
			TracerData["MythicResumeFrame"]["BST"..value]:SetTextColor(1, 1, 1, 1);
		end
		--Score
		TracerData["MythicResumeFrame"]["Score"..value]:SetText(TracerDB.Toons[toon]["Mythic"][value][8]);		
	end
	--Nettoyage pour Neltharus
	TracerData["MythicResumeFrame"]["BW2358"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BSF2358"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BST2358"]:SetText(nil);
	TracerData["MythicResumeFrame"]["Score2358"]:SetText(nil);
	--Nettoyage pour Salles de l'imprégnation
	TracerData["MythicResumeFrame"]["BW2381"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BSF2381"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BST2381"]:SetText(nil);
	TracerData["MythicResumeFrame"]["Score2381"]:SetText(nil);
	--Nettoyage pour Creux des Fougerobes
	TracerData["MythicResumeFrame"]["BW2379"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BSF2379"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BST2379"]:SetText(nil);
	TracerData["MythicResumeFrame"]["Score2379"]:SetText(nil);
	--Nettoyage pour Uldaman : Héritage de Tyr
	TracerData["MythicResumeFrame"]["BW2354"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BSF2354"]:SetText(nil);
	TracerData["MythicResumeFrame"]["BST2354"]:SetText(nil);
	TracerData["MythicResumeFrame"]["Score2354"]:SetText(nil);

	--Liste de donjons fait cette semaine et niveau
	TracerData["MythicResumeFrame"]["Title2"]:SetText(TracerData.L["Liste des mm+ fait cette semaine"].." ("..#TracerDB.Toons[toon]["MythicList"]..")");	
	local j=1;	
	for i=1, 8, 1 do
		TracerData["MythicResumeFrame"]["MythicWeekName"..i]:SetText("--");
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..i]:SetText("--");	
	end
	for index, value in ipairs(TracerDB.Toons[toon]["MythicList"]) do
		TracerData["MythicResumeFrame"]["MythicWeekName"..index]:SetText(TracerDB.MythicInfo[value[2]]);
		TracerData["MythicResumeFrame"]["MythicWeekLevel"..index]:SetText(value[1]);		
		if j == 8 then
			break;
		end
		j = j + 1;		
	end
	
	--Liste des coffres et niveau
	local t = {1, 2, 3};
	for index, value in ipairs(t) do
		if TracerDB.Toons[toon]["MythicReward"][value] then
			if TracerDB.Toons[toon]["MythicReward"][value]["level"] ~= 0 then
				TracerData["MythicResumeFrame"]["ChestLevel"..index]:SetText(C_MythicPlus.GetRewardLevelFromKeystoneLevel(TracerDB.Toons[toon]["MythicReward"][value]["level"]));
			else
				TracerData["MythicResumeFrame"]["ChestLevel"..index]:SetText("--");
			end
		end
	end	

	TracerData["MythicResumeFrame"]:ClearAllPoints();
	TracerData["MythicResumeFrame"]:SetPoint("TOP", TracerData.Lines[1]["Toon"..TracerDB.Toons[toon]["Order"]][4], "BOTTOM");
	TracerData["MythicResumeFrame"]:Show();
end

--Fonctions scan
function TracerData.Function:IlvlChecking()
	local overall, equipped = GetAverageItemLevel();
	TracerDB["Toons"][TracerData.thisToon]["Ilvl"] = math.floor(equipped);	
	
	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
end

function TracerData.Function:HerodayChecking()
	if TracerDB.Toons[TracerData.thisToon]["Ilvl"] >= 342 then
		local doneToday, moneyAmount, moneyVar, experienceGained, experienceVar, numRewards, spellID = GetLFGDungeonRewards(2087);	--1046 Legion, 1671 BfA, 2087 SL, 
		if doneToday then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["HD"] = 1;
			TracerDB.Options.DisplayLine[1][3][1] = true;			
		else
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["HD"] = 0;
		end
	else
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["HD"] = -1;	
	end
	
	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
end

function TracerData.Function:MythicPlusBestWeeklyChecking()	
	local MythicResume = {};
	local t = {};
			
	--Creation des emplacements de sauvegarde pour les mm+
	for key, value in pairs(TracerDB.MythicInfo) do
		MythicResume[key] = {false, -1, -1, -1, -1, -1, -1, 0, 0, 0};	--MM0, best timée weekly, best non timée weekly, 
																--best season fortif , timed or not
																--best season tyra, times or not
																--score total, score fortified, score tyra
	end	
		
	if TracerDB.Toons[TracerData.thisToon]["Level"] == 70 then
		local flag = 0;	
		local bestweeklylevel = -1;			

		--Mythic+ +0		
		local InstanceLockInfo = TracerData.Function:GetLockInstance();
		if InstanceLockInfo ~= nil then
			for index, value in ipairs(InstanceLockInfo) do
				if (value.difficulty == 23) and (value.reset ~= 0) and (value.encounterProgress == value.numEncounters) then	--23 : "Donjon mythic+0"
					local mythicid = 0;
					for key1, value1 in pairs(TracerDB.MythicInfo) do
						if value.name == value1 then
							mythicid = key1;
						end
					end
					if mythicid ~= 0 then
						MythicResume[mythicid][1] = true;	
						if MythicResume[mythicid][2] == -1 then
							MythicResume[mythicid][2] = 0;			
						end	
					end
					bestweeklylevel = 0;
				end
			end
		end

		--Liste des mm+ fait dans la semaine	
		local weeklyruns = C_MythicPlus.GetRunHistory(1, 1);		
		t = {};		
		if weeklyruns then
			for i=40, 1, -1 do
				for j=1, #weeklyruns, 1 do
					if (weeklyruns[j]["level"] == i) and (weeklyruns[j]["thisWeek"]) then
						table.insert(t, {weeklyruns[j]["level"], weeklyruns[j]["mapChallengeModeID"], weeklyruns[j]["completed"], weeklyruns[j]["thisWeek"]});
					end
				end
			end
		end
		TracerDB.Toons[TracerData.thisToon]["MythicList"] = t;
		--Détection des Mythic+ fait cette semaine et enregistrement (v2)
		for index, value in ipairs(t) do
			--Fait cette semaine
			if value[4] and MythicResume[value[2]] then
				--Timée
				if value[3] then
					if value[1] > MythicResume[value[2]][2] then
						MythicResume[value[2]][2] = value[1];
					end
				--Non timée
				else
					if value[1] > MythicResume[value[2]][3] then
						MythicResume[value[2]][3] = value[1];
					end				
				end
			end
		end
		
		--Détection du meilleur de la semaine (v2)
		if t[1] then
			bestweeklylevel = t[1][1];
		end
		
		-- --Détection du Mythic+ qui vient d'être terminé
		-- local mapChallengeModeID, level, timetodo, onTime, keystoneUpgradeLevels, practiceRun = C_ChallengeMode.GetCompletionInfo()
		-- if mapChallengeModeID ~= 0 then	
			-- if onTime then
				-- if TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID] then
					-- if level > TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID][2] then
						-- TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID][2] = level;						
					-- end
				-- end
				-- --print("Donjon "..TracerDB.MythicInfo[mapChallengeModeID].." mm+ terminé dans les temps de niveau : "..level);				
			-- else	
				-- if TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID] then
					-- if level > TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID][3] then
						-- TracerDB.Toons[TracerData.thisToon]["Mythic"][mapChallengeModeID][3] = level;						
					-- end
				-- end	
				-- --print("Donjon "..TracerDB.MythicInfo[mapChallengeModeID].." mm+ terminé non timé de niveau : "..level);				
			-- end
		-- end	
		
		--Meilleur de la saison
		t = {};
		local fortiname = C_ChallengeMode.GetAffixInfo(10);
		for key, value in pairs(TracerDB.MythicInfo) do
			t[key] = {};
			t[key]["affixScores"], t[key]["bestOverAllScore"] = C_MythicPlus.GetSeasonBestAffixScoreInfoForMap(key)
		end

		for key, value in pairs(t) do
			if value.bestOverAllScore then
				MythicResume[key][8] = value.bestOverAllScore;
			end
			if value.affixScores then
				for index2, value2 in pairs(value.affixScores) do
					if value2.name == fortiname then
						MythicResume[key][4] = value2.level;
						MythicResume[key][5] = value2.overTime;
						MythicResume[key][9] = value2.score;						
					else
						MythicResume[key][6] = value2.level;
						MythicResume[key][7] = value2.overTime;
						MythicResume[key][10] = value2.score;						
					end
				end
			end
		end
		TracerDB.Toons[TracerData.thisToon]["MythicBestSeason"] = t;
		
		--Save Meilleur de la semaine
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MD"] = bestweeklylevel;
		
		--Save des récompenses du coffre
		TracerDB.Toons[TracerData.thisToon]["MythicReward"] = C_WeeklyRewards.GetActivities(1);
		
		--Save des données
		TracerDB.Toons[TracerData.thisToon]["Mythic"] = MythicResume;
		
		--Score MM+ de la saison
		TracerDB.Toons[TracerData.thisToon]["MythicScore"] = C_ChallengeMode.GetOverallDungeonScore(); 
		TracerDB.Toons[TracerData.thisToon]["MythicScoreColor"] = {
			["r"] = 1, 
			["g"] = 1,
			["b"] = 1,
			};		
		if C_ChallengeMode.GetDungeonScoreRarityColor(TracerDB.Toons[TracerData.thisToon]["MythicScore"]) then
			TracerDB.Toons[TracerData.thisToon]["MythicScoreColor"] = C_ChallengeMode.GetDungeonScoreRarityColor(TracerDB.Toons[TracerData.thisToon]["MythicScore"]);
		end
		
		--Demande d'actualisation des récompenses du coffre
		C_MythicPlus.RequestRewards();
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MD"] = -2		
	end
	
	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
end

function TracerData.Function:MythicPlusChest()
	if TracerDB.Toons[TracerData.thisToon]["Level"] == 70 then		
		local chest = C_WeeklyRewards.HasAvailableRewards();
		if chest then
			--info pour le MC
			TracerDB.Toons[TracerData.thisToon]["Quests"]["MC"] = 0;
			TracerDB.Options.DisplayLine[1][5][1] = true;	--Affichage de la ligne
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["MC"] = 1;
		end
	end
	
	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
end

function TracerData.Function:MythicPlusKey()
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 70 then return end

	local keydungeonId, keydungeonName, keylevel = 0, 0, 0;	
	--Cherche dans les sacs une clé
	local bagId = {0, 1, 2, 3, 4, -1, 5, 6, 7, 8, 9, 10, 11, -3};	--0 à 4 perso, -1 banque, 5 à 11 sac de banque, -3 compo
	local containerInfo = {};
	local KeyInfo = 0;
	local KeyInfoSL = 0;
	local KeyInfoLegion = 0;
	for index, value in ipairs(bagId) do
		for i=1, C_Container.GetContainerNumSlots(value) do
			containerInfo = C_Container.GetContainerItemInfo(value, i);
			if containerInfo and (containerInfo.itemID == 180653) then	--modif			
				KeyInfo = containerInfo.hyperlink;
			end			
			-- if (itemID == 180653) then				
				-- KeyInfoSL = hyperlink;
			-- end
			if containerInfo and (containerInfo.itemID == 187786) then				
				KeyInfoLegion = containerInfo.hyperlink;
			end					
		end
	end
	
	--Traitement de l'information (Extension en cours)
	if KeyInfo ~= 0 then		--Si j'ai une clé
		--Pour juste avoir le numéro et le donjon
		local parts = {strsplit(':', KeyInfo)}
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][1] = tonumber(parts[3]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][2] = tonumber(parts[4]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][3] = tonumber(parts[5]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][4] = tonumber(parts[6]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][5] = tonumber(parts[7]);
		parts = {strsplit('|', parts[8])}
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][6] = tonumber(parts[1]);		
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][1] = 0;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MK"][2] = 0;
	end
	--Traitement de l'information (Legion)
	if KeyInfoLegion ~= 0 then		--Si j'ai une clé
		--Pour juste avoir le numéro et le donjon
		local parts = {strsplit(':', KeyInfoLegion)}
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][1] = tonumber(parts[3]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][2] = tonumber(parts[4]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][3] = tonumber(parts[5]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][4] = tonumber(parts[6]);
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][5] = tonumber(parts[7]);
		parts = {strsplit('|', parts[8])}
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][6] = tonumber(parts[1]);		
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][1] = 0;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["MKLegion"][2] = 0;
	end	
	
	--Affichage
	TracerData.Function:WindowUpdateGeneralInfos();
end

--Fonctions pour les Tooltip
function TracerData.Function:GoldTooltip()
	local list = {};
	local finallist = {};
	local total = 0;
	
	--Création de la list
	for key, value in pairs(TracerDB.Toons) do
		list[key] = value["PO"];
		total = total + value["PO"];			
	end
	--Triage par ordre alphabétique
	local a = {};
	for key, value in pairs(list) do
		table.insert(a, key);
	end
	table.sort(a);
	for index, value in ipairs(a) do
		table.insert(finallist, {value, list[value]});
	end

    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPRIGHT", TracerData.Lines[1][1], "TOPLEFT");
    GameTooltip:AddDoubleLine("Gold", TracerData.Function:format_thousand(total), 1, 1, 1, 1 ,1, 1);
    GameTooltip:AddLine(" ", 1, 1, 1);
	
	for index, value in ipairs(finallist) do
		local r, g, b = TracerDB.Toons[value[1]]["ClassColor"]["r"], TracerDB.Toons[value[1]]["ClassColor"]["g"], TracerDB.Toons[value[1]]["ClassColor"]["b"]
		GameTooltip:AddDoubleLine(TracerDB.Toons[value[1]].Name.." - "..TracerDB.Toons[value[1]].Realm, TracerData.Function:format_thousand(value[2]), r, g, b, 1 ,1, 1);	
	end
	
	GameTooltip:Show();
end

function TracerData.Function:InvasionsTooltip()
	local expansion = {"BfA", "Legion"};
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPLEFT", TracerData.Buttons.Invasions, "BOTTOMLEFT");	
		
	for index, value in ipairs(expansion) do
		GameTooltip:AddLine(invIndex[value]["title"])
		if invIndex[value]["baseTime"][TracerData.region] then
			-- baseTime provided
			local timeLeft, zoneName = TracerData.Function:GetCurrentInvasion(value)
			if timeLeft then
				timeLeft = timeLeft / 60
				if GetLocale() == "frFR" then
					GameTooltip:AddDoubleLine("Invasion en cours : " .. zoneName, format("%dh %.2dm", timeLeft / 60, timeLeft % 60), 1, 1, 1, 0, 1, 0);
				else
					GameTooltip:AddDoubleLine("Current Invasion : " .. zoneName, format("%dh %.2dm", timeLeft / 60, timeLeft % 60), 1, 1, 1, 0, 1, 0);
				end
			end
			local futureTable, i = TracerData.Function:GetFutureInvasion(value)
			for i = 1, #futureTable do
				local nextTime, zoneName = unpack(futureTable[i])
				if GetLocale() == "frFR" then
					GameTooltip:AddDoubleLine("Prochaine Invasion : " .. zoneName, date("%d/%m %H:%M", nextTime), 1, 1, 1, 1, 1, 1);
				else
					GameTooltip:AddDoubleLine("Next Invasion : " .. zoneName, date("%m/%d %H:%M", nextTime), 1, 1, 1, 1, 1, 1);
				end				
			end
		end
	end		
	
	GameTooltip:Show();
end

function TracerData.Function:BattlePetTooltip()

end

