local TracerName, TracerData = ...

local CTAQuestsId = {
	--Horde
	52958,	--Drustvar
	52956,	--Rade de Tiragarde
	52957,	--Vallée Chantorage
	52954,	--Nazmir	
	52953,	--Vol'dun
	52952,	--Zuldazar
	59016,	--Uldum
	59017,	--Val de l'Eternel Printemps
	56650,	--Mécagone
	56148,	--Nazjatar
	--Ally
	52944,	--Drustvar
	52948,	--Rade de Tiragarde
	52782,	--Vallée Chantorage
	52949,	--Nazmir	
	52950,	--Vol'dun
	52951,	--Zuldazar
	59019,	--Uldum
	59018,	--Val de l'Eternel Printemps
	56649,	--Mécagone
	56648,	--Nazjatar		
};
	
function TracerData.Function:WindowCreatePVP()
	local count = 0;
	--DB
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[10];
	TracerDB.ListLine[10] = {
		"25 kills", 
		};
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(10, headername);
	
	--Affichage
	TracerData.Function:WindowUpdatePVP();

	--Tooltips

	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end	
	
	--Gestion 25 kill
	TracerData.Lines[10][1]:RegisterEvent("QUEST_LOG_UPDATE");	
	TracerData.Lines[10][1]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:PVPQuestsUpdate();		
	end)
end

function TracerData.Function:WindowUpdatePVP()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[10] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					count = 0;
					--25 kills
					if i == 1 then
						TracerData.Lines[10]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
						if (value1.Level ~= 60) or (value1.PVP["25kill"] == -2) then
							TracerData.Lines[10]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[10]["Toon"..index][i]["Title"]:SetText("NA");						
						elseif value1.PVP["25kill"] == 26 then
							TracerData.Lines[10]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[10]["Toon"..index][i]["Title"]:SetText(nil);					
						elseif value1.PVP["25kill"] == -1 then
							TracerData.Lines[10]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							TracerData.Lines[10]["Toon"..index][i]["Title"]:SetText(nil);						
						else
							TracerData.Lines[10]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[10]["Toon"..index][i]["Title"]:SetText(value1.PVP["25kill"].."/25");	
						end
					end
				end
			end
		end
	end
end

--Fonctions scan
function TracerData.Function:PVPConquestCap()
	if TracerDB.Toons[TracerData.thisToon]["Level"] ~= 50 then	return end --pas d'actualisation si le perso n'est pas 50
	
	local quests = C_QuestLine.GetQuestLineQuests(782);	--liste des quêtes disponible pour le cap
	local currentQuestID = 0;
	for i, questID in ipairs(quests) do
		if C_QuestLog.IsOnQuest(questID) then
			currentQuestID = questID;
			break;
		end
	end	
	
	local numFulfilled, numRequired = 0, 0;	
	if currentQuestID ~= 0 then
		local objectives = C_QuestLog.GetQuestObjectives(currentQuestID);
		if not objectives or not objectives[1] then
			TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][1] = 500;
			TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][2] = 1;	
		else
			TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][1] = objectives[1].numFulfilled;
			TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][2] = 0;			
		end	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][1] = 500;
		TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][2] = 1;	
	end

	--Affichage
	if TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][2] == 1 then
		TracerData.Lines[10]["Toon"..TracerData.numthisToon][1]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		TracerData.Lines[10]["Toon"..TracerData.numthisToon][1]["Title"]:SetText(nil);					
	else
		TracerData.Lines[10]["Toon"..TracerData.numthisToon][1]["Texture2"]:SetTexture(nil);
		TracerData.Lines[10]["Toon"..TracerData.numthisToon][1]["Title"]:SetText(TracerDB.Toons[TracerData.thisToon]["PVP"]["CC"][1]);	
	end	
end

function TracerData.Function:PVPQuestsUpdate()
	if (TracerDB.Toons[TracerData.thisToon]["Level"] ~= 60) or (TracerDB.Toons[TracerData.thisToon]["Faction"] ~= "Alliance") then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["25kill"] = -2;
		TracerData.Function:WindowUpdatePVP();
		return 
	end
		
	--25kills
	local idquest25kills = 62910;
	if C_QuestLog.IsQuestFlaggedCompleted(idquest25kills) then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["25kill"] = 26;		
	else
		local questLogIndex = C_QuestLog.GetLogIndexForQuestID(idquest25kills);
		if questLogIndex then
			local _, _, isFinish, questDone, questNeed = GetQuestObjectiveInfo(idquest25kills, 1, false);
			if questDone then
				TracerDB.Toons[TracerData.thisToon]["PVP"]["25kill"] = questDone;				
			end
		else
			TracerDB.Toons[TracerData.thisToon]["PVP"]["25kill"] = -1;		
		end
	end
	
	--Affichage
	TracerData.Function:WindowUpdatePVP();
end

function TracerData.Function:PVPDailyUpdate()
	if TracerDB.Toons[TracerData.thisToon]["Level"] ~= 50 then	return end --pas d'actualisation si le perso n'est pas 50

	local honor, experience = 0, 0;
	--Random BG
	honor, experience = C_PvP.GetRandomBGRewards();
	if honor == 300 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][1] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][1] = 1;	
	end
	--Random BG Epic
	honor, experience = C_PvP.GetRandomEpicBGRewards();
	if honor == 450 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][2] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][2] = 1;	
	end	
	--Escarmouche
	honor, experience = C_PvP.GetArenaSkirmishRewards();
	if honor == 160 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][3] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["Daily"][3] = 1;	
	end
	--Rated 2v2
	honor, experience = C_PvP.GetArenaRewards(2);
	if honor == 200 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][1] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][1] = 1;	
	end		
	--Rated 3v3
	honor, experience = C_PvP.GetArenaRewards(3);
	if honor == 200 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][2] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][2] = 1;	
	end			
	--Rate Battleground
	honor, experience = C_PvP.GetRatedBGRewards();
	if honor == 600 then
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][3] = 0;	
	else
		TracerDB.Toons[TracerData.thisToon]["PVP"]["DailyRated"][3] = 1;	
	end
end

--Fonctions pour les Tooltip
function TracerData.Function:PVPCTAQuestsTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	for index, value in ipairs(TracerData.PVPCTAQuests) do
		if TracerDB.Toons[toon]["PVP"]["CTAQuests"][value] then
			if TracerDB.Toons[toon]["PVP"]["CTAQuests"][value][4] == 1 then
				GameTooltip:AddLine(TracerDB.QuestsName[value], 0, 1, 0);		
			else
				GameTooltip:AddDoubleLine(TracerDB.QuestsName[value], TracerDB.Toons[toon]["PVP"]["CTAQuests"][value][2].."/"..TracerDB.Toons[toon]["PVP"]["CTAQuests"][value][3], 1, 0, 0, 1 ,1, 1);				
			end
		end
	end

	GameTooltip:Show();		
end

function TracerData.Function:PVPDailyTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	if TracerDB.Toons[toon]["PVP"]["Daily"][1] == 1 then
		GameTooltip:AddLine(TracerData.L["Champ de Bataille"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Champ de Bataille"], 1, 0, 0);
	end
	if TracerDB.Toons[toon]["PVP"]["Daily"][2] == 1 then
		GameTooltip:AddLine(TracerData.L["Champ de Bataille Épique"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Champ de Bataille Épique"], 1, 0, 0);
	end
	if TracerDB.Toons[toon]["PVP"]["Daily"][3] == 1 then
		GameTooltip:AddLine(TracerData.L["Escarmouche"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Escarmouche"], 1, 0, 0);
	end	
	
	GameTooltip:Show();
end

function TracerData.Function:PVPDailyRankedTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	if TracerDB.Toons[toon]["PVP"]["DailyRated"][1] == 1 then
		GameTooltip:AddLine(TracerData.L["Arène 2v2"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Arène 2v2"], 1, 0, 0);
	end
	if TracerDB.Toons[toon]["PVP"]["DailyRated"][2] == 1 then
		GameTooltip:AddLine(TracerData.L["Arène 3v3"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Arène 3v3"], 1, 0, 0);
	end
	if TracerDB.Toons[toon]["PVP"]["DailyRated"][3] == 1 then
		GameTooltip:AddLine(TracerData.L["Champ de Bataille Côté"], 0, 1, 0);	
	else
	    GameTooltip:AddLine(TracerData.L["Champ de Bataille Côté"], 1, 0, 0);
	end	
	
	GameTooltip:Show();
end