local TracerName, TracerData = ...

local CurrentWeeklyEvent = 0;	--Flag pour l'évènement d'expéditions bonus
local CurrentWeeklyEventName = " ";

function TracerData.Function:WindowCreateWeeklyEvent1()
	TracerDB.ListLine[7] = {};

	--Détection de l'évènement de la semaine
	local AurasTable = {};
	AurasTable = TracerData.Function:GetAuras();
	for index, value in ipairs(AurasTable) do
		if value.spellId == 225788 then
			print("Tracer : "..TracerData.L["Évènement Bonus Expéditions"]);
			CurrentWeeklyEvent = 72728;
			CurrentWeeklyEventName = TracerData.L["Évènement Bonus Expéditions"];
			TracerDB.ListLine[7][1] = TracerData.L["Quête hebdo"];			
			break
		elseif value.spellId == 186403 then
			print("Tracer : "..TracerData.L["Évènement Bonus Champs de Bataille"]);
			CurrentWeeklyEvent = 62637;
			CurrentWeeklyEventName = TracerData.L["Évènement Bonus Champs de Bataille"];			
			TracerDB.ListLine[7][1] = TracerData.L["Quête hebdo"];			
			break
		elseif value.spellId == 225787 then
			print("Tracer : "..TracerData.L["Évènement Bonus Donjons DF"]);
			CurrentWeeklyEvent = 72722;
			CurrentWeeklyEventName = TracerData.L["Évènement Bonus Donjons DF"];			
			TracerDB.ListLine[7][1] = TracerData.L["Quête hebdo"];			
			break			
		elseif value.spellId == 186406 then
			print("Tracer : "..TracerData.L["Évènement Bonus Mascottes"]);
			CurrentWeeklyEvent = 72721;
			CurrentWeeklyEventName = TracerData.L["Évènement Bonus Mascottes"];			
			TracerDB.ListLine[7][1] = TracerData.L["Quête hebdo"];			
			break
		elseif value.spellId == 186401 then
			print("Tracer : "..TracerData.L["Évènement Bonus Arène"]);
			CurrentWeeklyEvent = 72720;
			CurrentWeeklyEventName = TracerData.L["Évènement Bonus Arène"];			
			TracerDB.ListLine[7][1] = TracerData.L["Quête hebdo"];			
			break			
		end		
	end	
	
	--Arrêt de la fonction s'il n'y a pas d'évènement
	if CurrentWeeklyEvent == 0 then
		return	
	else
		TracerData.Function:WindowCreateWeeklyEvent2("WeeklyEvent", CurrentWeeklyEventName);
	end
end

function TracerData.Function:WindowCreateWeeklyEvent2(Event, NameEvent)
	--DB
	
	--Informations pour la création de la catégorie
	local headername = NameEvent;
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(7, headername);
	TracerDB.Options.DisplayHeader[7] = true;
	TracerDB.Options.Custom.DisplayHeader[7] = true;	

	if Event == "WeeklyEvent" then	
		for index, value in ipairs(TracerData.ListToons) do
			for i = 1, #TracerDB.ListLine[7] , 1 do
				for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
					if value == key1 then
						TracerData.Lines[7]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
						--"Quête de la semaine"
						if i == 1 then
							if value1["Quests"]["Weeklyquest"][1] == 1 then
								TracerData.Lines[7]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							elseif value1["Quests"]["Weeklyquest"][1] == 0 then
								TracerData.Lines[7]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								TracerData.Lines[7]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["Weeklyquest"][2].."/"..value1["Quests"]["Weeklyquest"][3]);
							elseif value1["Level"] >= 50 then
								TracerData.Lines[7]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							else
								TracerData.Lines[7]["Toon"..index][i]["Title"]:SetText("NA");
							end	
						end
					end
				end
			end
		end
	end
		
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Gestion de l'état
	TracerData.Lines[7][1]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[7][1]:RegisterEvent("QUEST_TURNED_IN");		
	TracerData.Lines[7][1]:SetScript("OnEvent", function(_, event)			
		C_Timer.After(3, function() TracerData.Function:EventBonusCheking(CurrentWeeklyEvent) end);
		end)
	
	--Premier checking
	TracerData.Function:EventBonusCheking(CurrentWeeklyEvent);
end

function TracerData.Function:WindowUpdateWeeklyEvent()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[7] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[7]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--Weekly Event
					if i == 1 then		
						TracerData.Lines[7]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						TracerData.Lines[7]["Toon"..index][i]["Title"]:SetText(nil);				
						if value1["Quests"]["Weeklyquest"][1] == 1 then
							TracerData.Lines[7]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						elseif value1["Quests"]["Weeklyquest"][1] == -1 then
							TracerData.Lines[7]["Toon"..index][i]["Title"]:SetText("NA");
						else
							TracerData.Lines[7]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["Weeklyquest"][2].."/"..value1["Quests"]["Weeklyquest"][3]);
						end
					end						
				end
			end
		end
	end
end

function TracerData.Function:EventBonusCheking(CurrentWeeklyEvent)
	local questLogIndex = C_QuestLog.GetLogIndexForQuestID(CurrentWeeklyEvent);
	local objectives	
	if TracerDB.Toons[TracerData.thisToon]["Level"] >= 70 then
		if C_QuestLog.IsQuestFlaggedCompleted(CurrentWeeklyEvent) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][1] = 1 ;
		else			
			if questLogIndex ~= 0 then
				local _, _, isFinish, questDone, questNeed = GetQuestObjectiveInfo(CurrentWeeklyEvent, 1, false);
				if questNeed and questDone then
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][1] = 0;
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][2] = questDone;
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][3] = questNeed;					
				end
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][1] = 0;	
			end
		end
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["Weeklyquest"][1] = -1;
	end
	
	--Actualisation
	TracerData.Function:WindowUpdateWeeklyEvent();
end
